=begin
#TimesheetsApi (params in:body)

# <p>Another API description</p> 

The version of the OpenAPI document: 1.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0

=end

require 'cgi'

module Quake::Timesheets
  class ApprovalTypesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a new Approval Type
    # @param [Hash] opts the optional parameters
    # @option opts [CreateApprovalTypesInput] :create_approval_types_input 
    # @return [ApprovalType]
    def create_approval_types(opts = {})
      data, _status_code, _headers = create_approval_types_with_http_info(opts)
      data
    end

    # Create a new Approval Type
    # @param [Hash] opts the optional parameters
    # @option opts [CreateApprovalTypesInput] :create_approval_types_input 
    # @return [Array<(ApprovalType, Integer, Hash)>] ApprovalType data, response status code and response headers
    def create_approval_types_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ApprovalTypesApi.create_approval_types ...'
      end
      # resource path
      local_var_path = '/api/v1/approval_types'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(opts[:'create_approval_types_input'] || opts[:body])

      # return_type
      return_type = opts[:debug_return_type] || 'ApprovalType'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['authToken']

      new_options = opts.merge(
        :operation => :"ApprovalTypesApi.create_approval_types",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ApprovalTypesApi#create_approval_types\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Search for approval types matching filters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :dataset_id Filter to the approval types belonging to one of the identified datasets
    # @return [Array<ApprovalType>]
    def index_approval_types(opts = {})
      data, _status_code, _headers = index_approval_types_with_http_info(opts)
      data
    end

    # Search for approval types matching filters
    # @param [Hash] opts the optional parameters
    # @option opts [String] :dataset_id Filter to the approval types belonging to one of the identified datasets
    # @return [Array<(Array<ApprovalType>, Integer, Hash)>] Array<ApprovalType> data, response status code and response headers
    def index_approval_types_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ApprovalTypesApi.index_approval_types ...'
      end
      # resource path
      local_var_path = '/api/v1/approval_types'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'dataset_id'] = opts[:'dataset_id'] if !opts[:'dataset_id'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<ApprovalType>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['authToken']

      new_options = opts.merge(
        :operation => :"ApprovalTypesApi.index_approval_types",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ApprovalTypesApi#index_approval_types\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
