=begin
#TimesheetsApi (params in:body)

# <p>Another API description</p> 

The version of the OpenAPI document: 1.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0

=end

require 'cgi'

module Quake::Timesheets
  class ApprovalsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a new Approval
    # @param [Hash] opts the optional parameters
    # @option opts [CreateApprovalsInput] :create_approvals_input 
    # @return [Approval]
    def create_approvals(opts = {})
      data, _status_code, _headers = create_approvals_with_http_info(opts)
      data
    end

    # Create a new Approval
    # @param [Hash] opts the optional parameters
    # @option opts [CreateApprovalsInput] :create_approvals_input 
    # @return [Array<(Approval, Integer, Hash)>] Approval data, response status code and response headers
    def create_approvals_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ApprovalsApi.create_approvals ...'
      end
      # resource path
      local_var_path = '/api/v1/approvals'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(opts[:'create_approvals_input'] || opts[:body])

      # return_type
      return_type = opts[:debug_return_type] || 'Approval'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['authToken']

      new_options = opts.merge(
        :operation => :"ApprovalsApi.create_approvals",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ApprovalsApi#create_approvals\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Search for approval types matching filters
    # @param dataset_id [String] Filter to the approvals belonging to one of the identified datasets
    # @param [Hash] opts the optional parameters
    # @return [Array<Approval>]
    def index_approvals(dataset_id, opts = {})
      data, _status_code, _headers = index_approvals_with_http_info(dataset_id, opts)
      data
    end

    # Search for approval types matching filters
    # @param dataset_id [String] Filter to the approvals belonging to one of the identified datasets
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<Approval>, Integer, Hash)>] Array<Approval> data, response status code and response headers
    def index_approvals_with_http_info(dataset_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ApprovalsApi.index_approvals ...'
      end
      # verify the required parameter 'dataset_id' is set
      if @api_client.config.client_side_validation && dataset_id.nil?
        fail ArgumentError, "Missing the required parameter 'dataset_id' when calling ApprovalsApi.index_approvals"
      end
      # resource path
      local_var_path = '/api/v1/approvals'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'dataset_id'] = dataset_id

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<Approval>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['authToken']

      new_options = opts.merge(
        :operation => :"ApprovalsApi.index_approvals",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ApprovalsApi#index_approvals\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
